library dpa.tables;

import 'package:dpa/dpa.dart';

class Tables {
  
  static final Map<Type,Table> map = new Map<Type,Table>();
  
  factory Tables() => const Tables._internal_();
  const Tables._internal_();
  
  add(Type _type){
    if(!map.containsKey(_type)){
      map.putIfAbsent(_type, () => new Table(_type)..compute());
    }
  }
  String toString(){
    String s="";
    map.values.forEach((_table)=> s += _table.toString()+"\n");
    return s;
  }
  Table get(Type _type){
    if(!map.containsKey(_type)){
      add(_type);
    }
    if(map.containsKey(_type)){
      return map[_type];
    }
    return null;
  }
}